﻿using UnityEngine;
using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using System.Collections;

namespace Mod
{
    public class Mod
    {
        //Made by JulianMagicCraft using Entity Creator thing :D
        public static void Main()
        {
            ModAPI.Register(
     new Modification()
     {
         OriginalItem = ModAPI.FindSpawnable("Human"),
         NameOverride = "SCP-939",
         DescriptionOverride = "SCP-939 is like a red and white evil dog who will bite you to death and make some sound particles when activating his Mouth",
         CategoryOverride = ModAPI.FindCategory("Entities"),
         ThumbnailOverride = ModAPI.LoadSprite("gologo.png"),
         AfterSpawn = (Instance) =>
         {
             var mouth1 = Instance.transform.Find("Body").Find("MiddleBody");
             var mouth2 = Instance.transform.Find("Body").Find("LowerBody");

             mouth1.gameObject.AddComponent<Train>();
             mouth2.gameObject.AddComponent<Train>();
            // PersonBehaviour WalterWhite = Instance.GetComponent<PersonBehaviour>();
             //   foreach (var Heisenberg in WalterWhite.Limbs)
             // {
             //  Heisenberg.BaseStrength += 8.5f;
             //  Heisenberg.Health *= 9999f;
             //  Heisenberg.InitialHealth *= 9999f;
             //  Heisenberg.ShotDamageMultiplier *= 0.1f;
             //  Heisenberg.BreakingThreshold += 11f;
             //  Heisenberg.RegenerationSpeed += 300f;
             //    Heisenberg.Vitality *= 50f;
             //      Heisenberg.ImpactPainMultiplier *= 0.1f;
             //      Heisenberg.Numbness *= 1f;
             //       Heisenberg.CirculationBehaviour.BloodFlow *= 3000f;
             //       Heisenberg.IsLethalToBreak = false;
             //Heisenberg.gameObject.AddComponent<Rainwater>();
             //     Heisenberg.gameObject.GetComponent<PhysicalBehaviour>().Disintegratable = false;
             // }

             foreach (var limb in Instance.GetComponent<PersonBehaviour>().Limbs)
             {
                 limb.gameObject.AddComponent<Rainwater>();
                 if (!limb.HasBrain)
                 {
                     limb.transform.parent.localPosition = Vector3.zero;
                 }
                 else
                 {
                     limb.transform.GetChild(0).gameObject.SetActive(false); //brain matter stuff
                }
                 if (limb.gameObject.GetComponent<GripBehaviour>() != null)
                 {
                     GameObject.Destroy(limb.gameObject.GetComponent<GripBehaviour>());
                 }
             }


             PersonBehaviour person = Instance.GetComponent<PersonBehaviour>();
             person.CountDeathAsStat = false;
             GameObject Limb1 = person.Limbs[0].gameObject;
             Limb1.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteSkin1.png");
             Limb1.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteFlesh1.png").texture);
             Limb1.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteBone1.png").texture);
             Limb1.GetComponent<SpriteRenderer>().material.SetTexture("_DamageTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteDamage1.png").texture);
             Limb1.transform.localPosition = new Vector3(0.007756911f, 0.1176766f, 0f);
             Limb1.transform.eulerAngles = new Vector3(0f, 0f, 0f) * Mathf.Sign(person.transform.localScale.x);
             Limb1.GetComponent<LimbBehaviour>().RoughClassification = LimbBehaviour.BodyPart.Torso;
             Limb1.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
             Limb1.GetComponent<SpriteRenderer>().sortingOrder = 0;
             Limb1.GetComponent<LimbBehaviour>().BaseStrength = 8.5f;
             Limb1.GetComponent<LimbBehaviour>().BloodMuscleStrengthRatio = 1f;
             Limb1.GetComponent<LimbBehaviour>().InitialHealth = 50f;
             Limb1.GetComponent<LimbBehaviour>().Health = 50f;
             Limb1.GetComponent<LimbBehaviour>().FakeUprightForce = 0.005f;
             Limb1.GetComponent<LimbBehaviour>().BreakingThreshold = 4f;
             Limb1.GetComponent<LimbBehaviour>().Vitality = 2f;
             Limb1.GetComponent<LimbBehaviour>().VitalParts = null;
             Limb1.GetComponent<CirculationBehaviour>().IsPump = false;
             Limb1.GetComponent<LimbBehaviour>().HasLungs = false;
             Limb1.GetComponent<LimbBehaviour>().IsLethalToBreak = false;
             Limb1.GetComponent<LimbBehaviour>().HasBrain = false;
             GameObject Limb2 = person.Limbs[1].gameObject;
             Limb2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteSkin2.png");
             Limb2.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteFlesh2.png").texture);
             Limb2.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteBone2.png").texture);
             Limb2.GetComponent<SpriteRenderer>().material.SetTexture("_DamageTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteDamage2.png").texture);
             Limb2.transform.localPosition = new Vector3(-0.8777494f, 0.03770754f, 0f);
             Limb2.transform.eulerAngles = new Vector3(0f, 0f, 0f) * Mathf.Sign(person.transform.localScale.x);
             Limb2.GetComponent<LimbBehaviour>().RoughClassification = LimbBehaviour.BodyPart.Torso;
             Limb2.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
             Limb2.GetComponent<SpriteRenderer>().sortingOrder = 0;
             Limb2.GetComponent<LimbBehaviour>().BaseStrength = 8.5f;
             Limb2.GetComponent<LimbBehaviour>().BloodMuscleStrengthRatio = 1f;
             Limb2.GetComponent<LimbBehaviour>().InitialHealth = 50f;
             Limb2.GetComponent<LimbBehaviour>().Health = 50f;
             Limb2.GetComponent<LimbBehaviour>().FakeUprightForce = 0.005f;
             Limb2.GetComponent<LimbBehaviour>().BreakingThreshold = 4f;
             Limb2.GetComponent<LimbBehaviour>().Vitality = 2f;
             Limb2.GetComponent<LimbBehaviour>().VitalParts = null;
             Limb2.GetComponent<CirculationBehaviour>().IsPump = false;
             Limb2.GetComponent<LimbBehaviour>().HasLungs = false;
             Limb2.GetComponent<LimbBehaviour>().IsLethalToBreak = false;
             Limb2.GetComponent<LimbBehaviour>().HasBrain = false;
             GameObject Limb3 = person.Limbs[2].gameObject;
             Limb3.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteSkin3.png");
             Limb3.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteFlesh3.png").texture);
             Limb3.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteBone3.png").texture);
             Limb3.GetComponent<SpriteRenderer>().material.SetTexture("_DamageTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteDamage3.png").texture);
             Limb3.transform.localPosition = new Vector3(-1.466968f, 0.08503723f, -0.1f);
             Limb3.transform.eulerAngles = new Vector3(0f, 0f, 348.0006f) * Mathf.Sign(person.transform.localScale.x);
             Limb3.GetComponent<LimbBehaviour>().RoughClassification = LimbBehaviour.BodyPart.Head;
             Limb3.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
             Limb3.GetComponent<SpriteRenderer>().sortingOrder = 0;
             Limb3.GetComponent<LimbBehaviour>().BaseStrength = 8.5f;
             Limb3.GetComponent<LimbBehaviour>().BloodMuscleStrengthRatio = 1f;
             Limb3.GetComponent<LimbBehaviour>().InitialHealth = 50f;
             Limb3.GetComponent<LimbBehaviour>().Health = 50f;
             Limb3.GetComponent<LimbBehaviour>().FakeUprightForce = 0.005f;
             Limb3.GetComponent<LimbBehaviour>().BreakingThreshold = 4f;
             Limb3.GetComponent<LimbBehaviour>().Vitality = 2f;
             Limb3.GetComponent<LimbBehaviour>().VitalParts = null;
             Limb3.GetComponent<CirculationBehaviour>().IsPump = true;
             Limb3.GetComponent<LimbBehaviour>().HasLungs = true;
             Limb3.GetComponent<LimbBehaviour>().IsLethalToBreak = true;
             Limb3.GetComponent<LimbBehaviour>().HasBrain = true;
             GameObject Limb4 = person.Limbs[3].gameObject;
             Limb4.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteSkin4.png");
             Limb4.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteFlesh4.png").texture);
             Limb4.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteBone4.png").texture);
             Limb4.GetComponent<SpriteRenderer>().material.SetTexture("_DamageTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteDamage4.png").texture);
             Limb4.transform.localPosition = new Vector3(-1.463763f, -0.3229979f, -0.1f);
             Limb4.transform.eulerAngles = new Vector3(0f, 0f, 17.99896f) * Mathf.Sign(person.transform.localScale.x);
             Limb4.GetComponent<LimbBehaviour>().RoughClassification = LimbBehaviour.BodyPart.Head;
             Limb4.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
             Limb4.GetComponent<SpriteRenderer>().sortingOrder = 0;
             Limb4.GetComponent<LimbBehaviour>().BaseStrength = 8.5f;
             Limb4.GetComponent<LimbBehaviour>().BloodMuscleStrengthRatio = 1f;
             Limb4.GetComponent<LimbBehaviour>().InitialHealth = 50f;
             Limb4.GetComponent<LimbBehaviour>().Health = 50f;
             Limb4.GetComponent<LimbBehaviour>().FakeUprightForce = 0.005f;
             Limb4.GetComponent<LimbBehaviour>().BreakingThreshold = 4f;
             Limb4.GetComponent<LimbBehaviour>().Vitality = 2f;
             Limb4.GetComponent<LimbBehaviour>().VitalParts = null;
             Limb4.GetComponent<CirculationBehaviour>().IsPump = true;
             Limb4.GetComponent<LimbBehaviour>().HasLungs = true;
             Limb4.GetComponent<LimbBehaviour>().IsLethalToBreak = true;
             Limb4.GetComponent<LimbBehaviour>().HasBrain = true;
             GameObject Limb5 = person.Limbs[4].gameObject;
             Limb5.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteSkin5.png");
             Limb5.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteFlesh5.png").texture);
             Limb5.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteBone5.png").texture);
             Limb5.GetComponent<SpriteRenderer>().material.SetTexture("_DamageTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteDamage5.png").texture);
             Limb5.transform.localPosition = new Vector3(-0.391287f, -0.7102993f, 0f);
             Limb5.transform.eulerAngles = new Vector3(0f, 0f, 0f) * Mathf.Sign(person.transform.localScale.x);
             Limb5.GetComponent<LimbBehaviour>().RoughClassification = LimbBehaviour.BodyPart.Head;
             Limb5.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
             Limb5.GetComponent<SpriteRenderer>().sortingOrder = 0;
             Limb5.GetComponent<LimbBehaviour>().BaseStrength = 8.5f;
             Limb5.GetComponent<LimbBehaviour>().BloodMuscleStrengthRatio = 1f;
             Limb5.GetComponent<LimbBehaviour>().InitialHealth = 50f;
             Limb5.GetComponent<LimbBehaviour>().Health = 50f;
             Limb5.GetComponent<LimbBehaviour>().FakeUprightForce = 0.005f;
             Limb5.GetComponent<LimbBehaviour>().BreakingThreshold = 4f;
             Limb5.GetComponent<LimbBehaviour>().Vitality = 2f;
             Limb5.GetComponent<LimbBehaviour>().VitalParts = null;
             Limb5.GetComponent<CirculationBehaviour>().IsPump = false;
             Limb5.GetComponent<LimbBehaviour>().HasLungs = false;
             Limb5.GetComponent<LimbBehaviour>().IsLethalToBreak = true;
             Limb5.GetComponent<LimbBehaviour>().HasBrain = true;
             GameObject Limb6 = person.Limbs[5].gameObject;
             Limb6.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteSkin6.png");
             Limb6.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteFlesh6.png").texture);
             Limb6.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteBone6.png").texture);
             Limb6.GetComponent<SpriteRenderer>().material.SetTexture("_DamageTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteDamage6.png").texture);
             Limb6.transform.localPosition = new Vector3(0.4069728f, -0.7105581f, 0f);
             Limb6.transform.eulerAngles = new Vector3(0f, 0f, 0f) * Mathf.Sign(person.transform.localScale.x);
             Limb6.GetComponent<LimbBehaviour>().RoughClassification = LimbBehaviour.BodyPart.Head;
             Limb6.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
             Limb6.GetComponent<SpriteRenderer>().sortingOrder = 0;
             Limb6.GetComponent<LimbBehaviour>().BaseStrength = 8.5f;
             Limb6.GetComponent<LimbBehaviour>().BloodMuscleStrengthRatio = 1f;
             Limb6.GetComponent<LimbBehaviour>().InitialHealth = 50f;
             Limb6.GetComponent<LimbBehaviour>().Health = 50f;
             Limb6.GetComponent<LimbBehaviour>().FakeUprightForce = 0.005f;
             Limb6.GetComponent<LimbBehaviour>().BreakingThreshold = 4f;
             Limb6.GetComponent<LimbBehaviour>().Vitality = 2f;
             Limb6.GetComponent<LimbBehaviour>().VitalParts = null;
             Limb6.GetComponent<CirculationBehaviour>().IsPump = false;
             Limb6.GetComponent<LimbBehaviour>().HasLungs = false;
             Limb6.GetComponent<LimbBehaviour>().IsLethalToBreak = true;
             Limb6.GetComponent<LimbBehaviour>().HasBrain = true;
             GameObject Limb7 = person.Limbs[6].gameObject;
             Limb7.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteSkin7.png");
             Limb7.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteFlesh7.png").texture);
             Limb7.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteBone7.png").texture);
             Limb7.GetComponent<SpriteRenderer>().material.SetTexture("_DamageTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteDamage7.png").texture);
             Limb7.transform.localPosition = new Vector3(-0.5053046f, -1.081706f, 0f);
             Limb7.transform.eulerAngles = new Vector3(0f, 0f, 0f) * Mathf.Sign(person.transform.localScale.x);
             Limb7.GetComponent<LimbBehaviour>().RoughClassification = LimbBehaviour.BodyPart.Head;
             Limb7.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
             Limb7.GetComponent<SpriteRenderer>().sortingOrder = 0;
             Limb7.GetComponent<LimbBehaviour>().BaseStrength = 8.5f;
             Limb7.GetComponent<LimbBehaviour>().BloodMuscleStrengthRatio = 1f;
             Limb7.GetComponent<LimbBehaviour>().InitialHealth = 50f;
             Limb7.GetComponent<LimbBehaviour>().Health = 50f;
             Limb7.GetComponent<LimbBehaviour>().FakeUprightForce = 0.005f;
             Limb7.GetComponent<LimbBehaviour>().BreakingThreshold = 4f;
             Limb7.GetComponent<LimbBehaviour>().Vitality = 2f;
             Limb7.GetComponent<LimbBehaviour>().VitalParts = null;
             Limb7.GetComponent<CirculationBehaviour>().IsPump = true;
             Limb7.GetComponent<LimbBehaviour>().HasLungs = true;
             Limb7.GetComponent<LimbBehaviour>().IsLethalToBreak = true;
             Limb7.GetComponent<LimbBehaviour>().HasBrain = true;
             GameObject Limb8 = person.Limbs[7].gameObject;
             Limb8.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteSkin8.png");
             Limb8.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteFlesh8.png").texture);
             Limb8.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteBone8.png").texture);
             Limb8.GetComponent<SpriteRenderer>().material.SetTexture("_DamageTex", ModAPI.LoadSprite("ferbCreatureSprites/LimbSpriteDamage8.png").texture);
             Limb8.transform.localPosition = new Vector3(0.2922972f, -1.0788f, 0f);
             Limb8.transform.eulerAngles = new Vector3(0f, 0f, 0f) * Mathf.Sign(person.transform.localScale.x);
             Limb8.GetComponent<LimbBehaviour>().RoughClassification = LimbBehaviour.BodyPart.Head;
             Limb8.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
             Limb8.GetComponent<SpriteRenderer>().sortingOrder = 0;
             Limb8.GetComponent<LimbBehaviour>().BaseStrength = 8.5f;
             Limb8.GetComponent<LimbBehaviour>().BloodMuscleStrengthRatio = 1f;
             Limb8.GetComponent<LimbBehaviour>().InitialHealth = 50f;
             Limb8.GetComponent<LimbBehaviour>().Health = 50f;
             Limb8.GetComponent<LimbBehaviour>().FakeUprightForce = 0.005f;
             Limb8.GetComponent<LimbBehaviour>().BreakingThreshold = 4f;
             Limb8.GetComponent<LimbBehaviour>().Vitality = 2f;
             Limb8.GetComponent<LimbBehaviour>().VitalParts = null;
             Limb8.GetComponent<CirculationBehaviour>().IsPump = true;
             Limb8.GetComponent<LimbBehaviour>().HasLungs = true;
             Limb8.GetComponent<LimbBehaviour>().IsLethalToBreak = true;
             Limb8.GetComponent<LimbBehaviour>().HasBrain = true;
             int limbCount = 8;

             GameObject.Destroy(Limb1.GetComponent<LimbBehaviour>().Joint);
             Limb1.GetComponent<LimbBehaviour>().HasJoint = false;
             Limb1.GetComponent<ConnectedNodeBehaviour>().Connections = new ConnectedNodeBehaviour[]{
       Limb6.GetComponent<ConnectedNodeBehaviour>(),
    };
             Limb1.GetComponent<CirculationBehaviour>().PushesTo = new CirculationBehaviour[]{
       Limb6.GetComponent<CirculationBehaviour>(),
    };
             Limb1.GetComponent<LimbBehaviour>().ConnectedLimbs = new List<LimbBehaviour>(){
       Limb6.GetComponent<LimbBehaviour>(),
    };
             Limb1.GetComponent<SkinMaterialHandler>().adjacentLimbs = new SkinMaterialHandler[]{
       Limb6.GetComponent<SkinMaterialHandler>(),
    };
             Limb2.GetComponent<GoreStringBehaviour>().Other = Limb1.GetComponent<Rigidbody2D>();
             var Limb2Joint = Limb2.GetComponent<LimbBehaviour>().Joint;
             Limb2Joint.anchor = new Vector2(0.2487059f, -0.09183075f);
             Limb2Joint.autoConfigureConnectedAnchor = true; Limb2Joint.connectedBody = Limb1.GetComponent<Rigidbody2D>();
             var lim2 = Limb2Joint.limits;
             lim2.min = 0f;
             lim2.max = 90f;
             Limb2Joint.limits = lim2;
             Limb2.GetComponent<ConnectedNodeBehaviour>().Connections = new ConnectedNodeBehaviour[]{
       Limb1.GetComponent<ConnectedNodeBehaviour>(),
       Limb3.GetComponent<ConnectedNodeBehaviour>(),
    };
             Limb2.GetComponent<CirculationBehaviour>().PushesTo = new CirculationBehaviour[]{
       Limb1.GetComponent<CirculationBehaviour>(),
       Limb3.GetComponent<CirculationBehaviour>(),
    };
             Limb2.GetComponent<LimbBehaviour>().ConnectedLimbs = new List<LimbBehaviour>(){
       Limb1.GetComponent<LimbBehaviour>(),
       Limb3.GetComponent<LimbBehaviour>(),
    };
             Limb2.GetComponent<SkinMaterialHandler>().adjacentLimbs = new SkinMaterialHandler[]{
       Limb1.GetComponent<SkinMaterialHandler>(),
       Limb3.GetComponent<SkinMaterialHandler>(),
    };
             Limb2Joint.useLimits = true;
             Limb3.GetComponent<LimbBehaviour>().Joint = Limb3.AddComponent<HingeJoint2D>();
             Limb3.GetComponent<LimbBehaviour>().HasJoint = true;
             Limb3.AddComponent<GoreStringBehaviour>().Other = Limb2.GetComponent<Rigidbody2D>();
             var Limb3Joint = Limb3.GetComponent<LimbBehaviour>().Joint;
             Limb3Joint.anchor = new Vector2(0.3323242f, 0.0592483f);
             Limb3Joint.autoConfigureConnectedAnchor = true; Limb3Joint.connectedBody = Limb2.GetComponent<Rigidbody2D>();
             var lim3 = Limb3Joint.limits;
             lim3.min = 0f;
             lim3.max = 90f;
             Limb3Joint.limits = lim3;
             Limb3.GetComponent<ConnectedNodeBehaviour>().Connections = new ConnectedNodeBehaviour[]{
       Limb2.GetComponent<ConnectedNodeBehaviour>(),
    };
             Limb3.GetComponent<CirculationBehaviour>().PushesTo = new CirculationBehaviour[]{
       Limb2.GetComponent<CirculationBehaviour>(),
    };
             Limb3.GetComponent<LimbBehaviour>().ConnectedLimbs = new List<LimbBehaviour>(){
       Limb2.GetComponent<LimbBehaviour>(),
    };
             Limb3.GetComponent<SkinMaterialHandler>().adjacentLimbs = new SkinMaterialHandler[]{
       Limb2.GetComponent<SkinMaterialHandler>(),
    };
             Limb3Joint.useLimits = true;
             Limb4.GetComponent<GoreStringBehaviour>().Other = Limb2.GetComponent<Rigidbody2D>();
             var Limb4Joint = Limb4.GetComponent<LimbBehaviour>().Joint;
             Limb4Joint.anchor = new Vector2(0.2905615f, -0.0571357f);
             Limb4Joint.autoConfigureConnectedAnchor = true; Limb4Joint.connectedBody = Limb2.GetComponent<Rigidbody2D>();
             var lim4 = Limb4Joint.limits;
             lim4.min = 0f;
             lim4.max = 90f;
             Limb4Joint.limits = lim4;
             Limb4.GetComponent<ConnectedNodeBehaviour>().Connections = new ConnectedNodeBehaviour[]{
       Limb2.GetComponent<ConnectedNodeBehaviour>(),
    };
             Limb4.GetComponent<CirculationBehaviour>().PushesTo = new CirculationBehaviour[]{
       Limb2.GetComponent<CirculationBehaviour>(),
    };
             Limb4.GetComponent<LimbBehaviour>().ConnectedLimbs = new List<LimbBehaviour>(){
       Limb2.GetComponent<LimbBehaviour>(),
    };
             Limb4.GetComponent<SkinMaterialHandler>().adjacentLimbs = new SkinMaterialHandler[]{
       Limb2.GetComponent<SkinMaterialHandler>(),
    };
             Limb4Joint.useLimits = true;
             Limb5.GetComponent<GoreStringBehaviour>().Other = Limb1.GetComponent<Rigidbody2D>();
             var Limb5Joint = Limb5.GetComponent<LimbBehaviour>().Joint;
             Limb5Joint.anchor = new Vector2(-0.002566397f, 0.2347758f);
             Limb5Joint.autoConfigureConnectedAnchor = true; Limb5Joint.connectedBody = Limb1.GetComponent<Rigidbody2D>();
             var lim5 = Limb5Joint.limits;
             lim5.min = 0f;
             lim5.max = 90f;
             Limb5Joint.limits = lim5;
             Limb5.GetComponent<ConnectedNodeBehaviour>().Connections = new ConnectedNodeBehaviour[]{
       Limb1.GetComponent<ConnectedNodeBehaviour>(),
       Limb7.GetComponent<ConnectedNodeBehaviour>(),
    };
             Limb5.GetComponent<CirculationBehaviour>().PushesTo = new CirculationBehaviour[]{
       Limb1.GetComponent<CirculationBehaviour>(),
       Limb7.GetComponent<CirculationBehaviour>(),
    };
             Limb5.GetComponent<LimbBehaviour>().ConnectedLimbs = new List<LimbBehaviour>(){
       Limb1.GetComponent<LimbBehaviour>(),
       Limb7.GetComponent<LimbBehaviour>(),
    };
             Limb5.GetComponent<SkinMaterialHandler>().adjacentLimbs = new SkinMaterialHandler[]{
       Limb1.GetComponent<SkinMaterialHandler>(),
       Limb7.GetComponent<SkinMaterialHandler>(),
    };
             Limb5Joint.useLimits = true;
             Limb6.GetComponent<GoreStringBehaviour>().Other = Limb1.GetComponent<Rigidbody2D>();
             var Limb6Joint = Limb6.GetComponent<LimbBehaviour>().Joint;
             Limb6Joint.anchor = new Vector2(0.004636586f, 0.1988962f);
             Limb6Joint.autoConfigureConnectedAnchor = true; Limb6Joint.connectedBody = Limb1.GetComponent<Rigidbody2D>();
             var lim6 = Limb6Joint.limits;
             lim6.min = 0f;
             lim6.max = 90f;
             Limb6Joint.limits = lim6;
             Limb6.GetComponent<ConnectedNodeBehaviour>().Connections = new ConnectedNodeBehaviour[]{
       Limb1.GetComponent<ConnectedNodeBehaviour>(),
       Limb8.GetComponent<ConnectedNodeBehaviour>(),
    };
             Limb6.GetComponent<CirculationBehaviour>().PushesTo = new CirculationBehaviour[]{
       Limb1.GetComponent<CirculationBehaviour>(),
       Limb8.GetComponent<CirculationBehaviour>(),
    };
             Limb6.GetComponent<LimbBehaviour>().ConnectedLimbs = new List<LimbBehaviour>(){
       Limb1.GetComponent<LimbBehaviour>(),
       Limb8.GetComponent<LimbBehaviour>(),
    };
             Limb6.GetComponent<SkinMaterialHandler>().adjacentLimbs = new SkinMaterialHandler[]{
       Limb1.GetComponent<SkinMaterialHandler>(),
       Limb8.GetComponent<SkinMaterialHandler>(),
    };
             Limb6Joint.useLimits = true;
             Limb7.GetComponent<GoreStringBehaviour>().Other = Limb5.GetComponent<Rigidbody2D>();
             var Limb7Joint = Limb7.GetComponent<LimbBehaviour>().Joint;
             Limb7Joint.anchor = new Vector2(0.1612164f, 0.05054677f);
             Limb7Joint.autoConfigureConnectedAnchor = true; Limb7Joint.connectedBody = Limb5.GetComponent<Rigidbody2D>();
             var lim7 = Limb7Joint.limits;
             lim7.min = 0f;
             lim7.max = 90f;
             Limb7Joint.limits = lim7;
             Limb7.GetComponent<ConnectedNodeBehaviour>().Connections = new ConnectedNodeBehaviour[]{
       Limb5.GetComponent<ConnectedNodeBehaviour>(),
    };
             Limb7.GetComponent<CirculationBehaviour>().PushesTo = new CirculationBehaviour[]{
       Limb5.GetComponent<CirculationBehaviour>(),
    };
             Limb7.GetComponent<LimbBehaviour>().ConnectedLimbs = new List<LimbBehaviour>(){
       Limb5.GetComponent<LimbBehaviour>(),
    };
             Limb7.GetComponent<SkinMaterialHandler>().adjacentLimbs = new SkinMaterialHandler[]{
       Limb5.GetComponent<SkinMaterialHandler>(),
    };
             Limb7Joint.useLimits = true;
             Limb8.GetComponent<GoreStringBehaviour>().Other = Limb6.GetComponent<Rigidbody2D>();
             var Limb8Joint = Limb8.GetComponent<LimbBehaviour>().Joint;
             Limb8Joint.anchor = new Vector2(0.174711f, 0.04693174f);
             Limb8Joint.autoConfigureConnectedAnchor = true; Limb8Joint.connectedBody = Limb6.GetComponent<Rigidbody2D>();
             var lim8 = Limb8Joint.limits;
             lim8.min = 0f;
             lim8.max = 90f;
             Limb8Joint.limits = lim8;
             Limb8.GetComponent<ConnectedNodeBehaviour>().Connections = new ConnectedNodeBehaviour[]{
       Limb6.GetComponent<ConnectedNodeBehaviour>(),
    };
             Limb8.GetComponent<CirculationBehaviour>().PushesTo = new CirculationBehaviour[]{
       Limb6.GetComponent<CirculationBehaviour>(),
    };
             Limb8.GetComponent<LimbBehaviour>().ConnectedLimbs = new List<LimbBehaviour>(){
       Limb6.GetComponent<LimbBehaviour>(),
    };
             Limb8.GetComponent<SkinMaterialHandler>().adjacentLimbs = new SkinMaterialHandler[]{
       Limb6.GetComponent<SkinMaterialHandler>(),
    };
             Limb8Joint.useLimits = true;


             for (int i = limbCount; i < person.Limbs.Length; i++)
             {
                 person.Limbs[i].PhysicalBehaviour.Disintegrate();
             }

             foreach (var Limb in person.Limbs)
             {
                 Limb.gameObject.FixColliders();
             }
             var nocol = Instance.AddComponent<NoCollide>();
             nocol.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
             nocol.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();

             person.LinkedPoses[PoseState.Rest].Angles = new List<RagdollPose.LimbPose>();
             foreach (var limb in person.Limbs)
             {
                 if (limb != null && !limb.PhysicalBehaviour.isDisintegrated && limb.HasJoint)
                 {
                     person.LinkedPoses[PoseState.Rest].Angles.Add(new RagdollPose.LimbPose(limb, limb.Joint.jointAngle + (limb.transform.eulerAngles.z - limb.Joint.connectedBody.transform.eulerAngles.z) * Mathf.Sign(person.transform.localScale.x)));
                 }
             }
             person.LinkedPoses[PoseState.Rest].ConstructDictionary();

             person.LinkedPoses[PoseState.Protective].Angles = new List<RagdollPose.LimbPose>();
             foreach (var limb in person.Limbs)
             {
                 if (limb != null && !limb.PhysicalBehaviour.isDisintegrated && limb.HasJoint)
                 {
                     person.LinkedPoses[PoseState.Protective].Angles.Add(new RagdollPose.LimbPose(limb, limb.Joint.jointAngle + (limb.transform.eulerAngles.z - limb.Joint.connectedBody.transform.eulerAngles.z) * Mathf.Sign(person.transform.localScale.x)));
                 }
             }
             person.LinkedPoses[PoseState.Protective].ConstructDictionary();

             foreach (var item in person.Limbs)
             {
                 if (item.RoughClassification == LimbBehaviour.BodyPart.Head)
                 {
                     item.NodeBehaviour.IsRoot = true;
                     item.NodeBehaviour.Value = 1000000;
                 }
                 else
                 {
                     item.NodeBehaviour.IsRoot = false;
                     item.NodeBehaviour.Value = 100000;
                 }
             }

             foreach (var item in person.Limbs)
             {
                 if (item.RoughClassification == LimbBehaviour.BodyPart.Head)
                 {
                     item.NodeBehaviour.RootPropagation();
                 }
             }
         }
     }
 );

        }

        public class Rainwater : MonoBehaviour
        {
            public void Start()
            {
             

            }
            public void Pasta(GameObject Spaghetti)
            {
               
            }
            public void Update()
            {
                var person = gameObject.GetComponent<LimbBehaviour>().Person;

                foreach (var jmc in person.Limbs)
                {
                    jmc.IsZombie = false;
                    jmc.Health = jmc.InitialHealth;
                    jmc.Numbness = 0f;
                    jmc.HealBone();

                    jmc.Person.Braindead = false;
                    jmc.Person.BrainDamaged = false;
                    jmc.Person.Consciousness = 1f;
                    jmc.Person.ShockLevel = 0f;
                    jmc.Person.PainLevel = 0f;
                    jmc.Person.OxygenLevel = 1f;
                    jmc.Person.AdrenalineLevel = 1f;

                    CirculationBehaviour circulationBehaviour = jmc.CirculationBehaviour;
                    float amount = circulationBehaviour.GetAmount(jmc.GetOriginalBloodType());
                    if (amount < 0.1f)
                    {
                        circulationBehaviour.AddLiquid(jmc.GetOriginalBloodType(), 1f - amount);
                    }
                    circulationBehaviour.BloodFlow = 1f;
                    circulationBehaviour.HealBleeding();
                    circulationBehaviour.BleedingRate = 0f;
                    circulationBehaviour.IsPump = circulationBehaviour.WasInitiallyPumping;
                }
            }


        }

        public class Train : MonoBehaviour
        {
            public void Start()
            {
                gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                   ModAPI.CreateParticleEffect("Vapor", transform.position);
                };
              
            }

           public void OnCollisionEnter2D(Collision2D jmcTrain)
            {
                jmcTrain.gameObject.GetComponent<LimbBehaviour>().Slice();
            }

            }






        }
    }
     
    





